package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateFirewallPolicyLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewCreateFirewallPolicyLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateFirewallPolicyLogic {
	return &CreateFirewallPolicyLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateFirewallPolicyLogic) CreateFirewallPolicy(req *types.CreateFirewallPolicyReq) (resp *types.CreateFirewallPolicyResp, err error) {
	// todo: add your logic here and delete this line
	CreateFirewallPolicyReq := &openstack.CreateFirewallPolicyReq{}
	err = copier.CopyWithOption(CreateFirewallPolicyReq, req, copier.Option{Converters: utils.Converters})
	CreateFirewallPolicyResp, err := l.svcCtx.OpenstackRpc.CreateFirewallPolicy(l.ctx, CreateFirewallPolicyReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&CreateFirewallPolicyResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &CreateFirewallPolicyResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
